# -*- coding: utf-8 -*-
from __future__ import division
import numpy as np
import matplotlib.mlab as mlab


def fdens_rife(x):
    """

    Args:
        x:.

    Returns:
        Un tupla de la forma (xc, f, p).

        * ``xc``: .
        * ``f``: .
        * ``p``: .

    """

    n = x.shape[0]

    p = mlab.prctile(x, range(0, 101, 5))
    d = np.diff(p)
    f = np.zeros(p.shape[0]-1)

    for j in range(p.shape[0]-1):
        mask = np.logical_and(x >= p[j], x < p[j+1])
        f[j] = np.sum(mask)

    f[-1] += 1
    f = f / (n * d)
    xc = p[:-1] + d / 2

    return (xc, f, p)
