# -*- coding: utf-8 -*-
import numpy as np


def dist_cnorm(x1, x2):
    """Distancia circular entre dos valores de una variable angular normalizada.

    Args:
        x1: Primer valor angular.
        x2: Segundo valor angular.

    Returns:
        Distancia circular.

    """

    aux = np.abs(x1 - x2)
    d = np.minimum(aux, 2 - aux)

    return d


if __name__ == "__main__":
    import doctest
    doctest.testmod(verbose=True, exclude_empty=True)
