# -*- coding: utf-8 -*-
from __future__ import division

import os
import numpy as np
import matplotlib.pyplot as plt
from scipy.stats import norm

plt.rc('text', usetex=True)
plt.rc('font', family='serif')

dir_cadiz = os.path.join('..', 'main', 'archivos_entrada', 'cadiz')


pf_V_modo_ls = 0.02, 0.033, 0.04, 0.1
xmax_ls= 450, 400, 300, 120

V = 25
beta = np.arange(-6,6,0.01)

p_fallo_estado = norm.cdf(-beta)

for pf_V_modo, xmax_p in zip(pf_V_modo_ls, xmax_ls):
    plt.figure()
    p_V_estado = pf_V_modo / p_fallo_estado
    Tr = 1/(1-(1-p_V_estado)**(1/V))

    plt.plot(Tr, beta)
    plt.xlabel(r'$T_r$ $(years)$')
    plt.ylabel(r'$\beta$')
    plt.grid(True)
    plt.xlim(xmax=xmax_p)
    plt.ylim(ymin=0)
    plt.savefig(os.path.join(dir_cadiz, 'verificacion', 'curva_beta_tr_p' + str(pf_V_modo) + '.png'), bbox_inches='tight')